#####################################
### Lodz University of Technology ###
### Institute of Electronics      ###
### Image Processing and          ###
### Computer Graphics             ###
### Marek Kocinski                ###
### 2014                          ###
#####################################

import vtk

imageReader = vtk.vtkImageReader()
imageReader .SetFileName ("qinp01_3000_036_3_256.raw")
imageReader .SetDataScalarTypeToUnsignedChar()
imageReader .SetDataByteOrder (0)
imageReader .SetFileDimensionality (3)
imageReader .SetDataOrigin (0,0,0)
imageReader .SetDataSpacing (1,1,1)
imageReader .SetDataExtent (0,255,0,255,0,255)
imageReader .SetNumberOfScalarComponents (1)
imageReader .Update ()


shrinker = vtk.vtkImageShrink3D ()
shrinker .SetInput (imageReader .GetOutput ())
shrinker .SetShrinkFactors (1,1,1)
shrinker .AveragingOn ()

gaussian = vtk.vtkImageGaussianSmooth ()
gaussian .SetDimensionality (3)
gaussian .SetStandardDeviations (1.0, 1.0, 1.0)
gaussian .SetRadiusFactor (1.0)
gaussian .SetInput (shrinker.GetOutput ())

marching = vtk.vtkMarchingCubes()
marching .SetInput (gaussian.GetOutput ())
marching .SetValue (1,50)
marching .ComputeScalarsOff ()
marching .ComputeGradientsOff ()
marching .ComputeNormalsOff ()


decimator = vtk.vtkDecimatePro ()
decimator .SetInput (marching .GetOutput ())
decimator .SetTargetReduction (0.1)
decimator .SetFeatureAngle (60)

smoother = vtk .vtkSmoothPolyDataFilter()
smoother .SetInput (decimator.GetOutput())
smoother .BoundarySmoothingOn()
smoother .FeatureEdgeSmoothingOn ()

normals = vtk.vtkPolyDataNormals ()
normals .SetInput (smoother .GetOutput())
normals .SetFeatureAngle (60)

stripper = vtk.vtkStripper ()
stripper .SetInput (normals.GetOutput ())

mapper = vtk.vtkPolyDataMapper ()
mapper .SetInput (stripper .GetOutput())
mapper .ScalarVisibilityOff ()

surf = vtk.vtkProperty ()
surf .SetColor(0.8,0.1,0.1)


actor = vtk.vtkActor()
actor .SetMapper (mapper)
actor .SetProperty (surf)

ren1 = vtk.vtkRenderer()
ren1 .AddActor (actor)

renWin = vtk.vtkRenderWindow ()
renWin .AddRenderer (ren1)

iren = vtk.vtkRenderWindowInteractor ()
iren .SetRenderWindow (renWin)

renWin.Render()
iren .Start ()

def close_window(iren):
    render_window = iren.GetRenderWindow()
    render_window.Finalize()
    iren.TerminateApp()
    
close_window(iren)
del renWin, iren
