#####################################
### Lodz University of Technology ###
### Institute of Electronics      ###
### Image Processing and          ###
### Computer Graphics             ###
### Marek Kocinski                ###
### 2014                          ###
#####################################

import vtk
 
# create a rendering window and renderer
ren = vtk.vtkRenderer()
ren.SetBackground (1.0,1.0,1.0)
renWin = vtk.vtkRenderWindow()
renWin.AddRenderer(ren)
 
# create a renderwindowinteractor
iren = vtk.vtkRenderWindowInteractor()
iren.SetRenderWindow(renWin)
 
# create source
source = vtk.vtkSphereSource()
source.SetCenter(0,0,0)
source.SetRadius(5.0)

cylinder = vtk.vtkCylinderSource ()
cylinder.SetRadius (2.0)
cylinder.SetHeight (15.0)
cylinder.SetCenter (10, 10, 10)
cylinder.SetResolution (20)
 
# mapper
mapper = vtk.vtkPolyDataMapper()
mapper.SetInput(source.GetOutput())

cylinderMapper = vtk.vtkPolyDataMapper ()
cylinderMapper.SetInput( cylinder.GetOutput() )
 
# actor
actor = vtk.vtkActor()
actor.SetMapper(mapper)

actor.GetProperty ().SetColor (1.0, 0.8, 0.7)
actor.GetProperty ().SetDiffuse (0.7)
actor .GetProperty ().SetSpecular (0.4)
actor .GetProperty ().SetSpecularPower (250)


cylinderActor = vtk.vtkActor()
cylinderActor.SetMapper( cylinderMapper )
cylinderActor .GetProperty ().SetColor (0.6, 0.8, 1.0)
 
# assign actor to the renderer
ren.AddActor(actor)
ren.AddActor( cylinderActor )
 
# enable user interface interactor
iren.Initialize()
renWin.Render()
iren.Start()


def close_window(iren):
    render_window = iren.GetRenderWindow()
    render_window.Finalize()
    iren.TerminateApp()
    
close_window(iren)
del renWin, iren